<div class="container detail-container">
    <div class="row mt-4">
        <div>
            <div *ngIf="location; else backToProgram" (click)="location.back()" class="back-link">Retour</div>
            <ng-template #backToProgram>
                <a [routerLink]="['/programs', program_id, module]" class="back-link">Retour au programme</a>
            </ng-template>
        </div>
        <h1 class="title text-center">
            {{
            module === 'areas' ? area?.properties.name :
            module === 'species_sites' ?
            speciesSite?.properties.name :
            module === 'sites'
            ? site?.properties.name
            : !!obs?.properties.nom_francais
            ? obs?.properties.nom_francais
            : obs?.properties.taxref?.nom_vern
            }}
        </h1>
    </div>
    <div class="row mb-4">
        <div class="col-md-4 pt-4 card box-shadow">
            <ng-container [ngSwitch]="true">
                <div *ngSwitchCase="module === 'areas'" class="card-body">
                    <h5 class="card-title">
                        Zone #{{
                        area_id
                        }}
                    </h5>
                    <h6 class="card-subtitle mb-2 text-muted">
                        Ajoutée le
                        {{
                        area?.properties.timestamp_create.substring(0, 10)
                        | date: 'longDate'
                        }}
                    </h6>
                    <p class="card-text">
                        Inventoriée par {{ area?.properties.obs_txt }}
                    </p>

                    <p *ngIf="area?.properties.species_sites.count; else noSpeciesSite" class="card-text">
                        <small class="text-muted">
                            {{
                            area.properties.species_sites.count
                            }}
                            individu(s)
                        </small>
                    </p>
                    <ng-template #noSpeciesSite>
                        <p class="card-text">
                            <small class="text-danger">Aucun individu enregistré :(</small>
                        </p>
                    </ng-template>
                    <a href="#" (click)="$event.preventDefault(); addAreaSpeciesSite()" class="btn btn-primary">Ajouter
                        un individu</a>
                </div>
                <div *ngSwitchCase="module === 'species_sites'" class="card-body">
                    <p *ngIf="speciesSite?.properties.species">
                        {{
                        speciesSite?.properties.species.nom_vern ?
                        speciesSite?.properties.species.nom_vern :
                        speciesSite?.properties.species.nom_complet
                        }}
                    </p>
                    <h5 class="card-title">
                        Individu #{{
                        species_site_id
                        }}
                    </h5>
                    <h6 class="card-subtitle mb-2 text-muted">
                        Ajouté le
                        {{
                        speciesSite?.properties.timestamp_create.substring(0, 10)
                        | date: 'longDate'
                        }}
                    </h6>
                    <p class="card-text">
                        Inventorié par {{ speciesSite?.properties.obs_txt }}
                    </p>

                    <p *ngIf="speciesSite?.properties.observations.count; else noObservations" class="card-text">
                        <small class="text-muted">
                            {{
                            speciesSite.properties.observations.count
                            }}
                            observations(s)
                        </small>
                    </p>
                    <ng-template #noObservations>
                        <p class="card-text">
                            <small class="text-danger">Aucune observation enregistrée :(</small>
                        </p>
                    </ng-template>
                    <a *ngIf="speciesSite && speciesSite.properties.json_data && speciesSite.properties.json_data.is_dead !== true"
                        href="#" (click)="$event.preventDefault(); addSpeciesSiteObservation()" class="btn btn-primary">
                        Ajouter une observation
                    </a>
                </div>
                <div *ngSwitchCase="module === 'sites'" class="card-body">
                    <h5 class="card-title">
                        {{ site?.properties.site_type.type | titlecase }} #{{
                        site_id
                        }}
                    </h5>
                    <h6 class="card-subtitle mb-2 text-muted">
                        Ajouté(e) le
                        {{
                        site?.properties.timestamp_create.substring(0, 10)
                        | date: 'longDate'
                        }}
                    </h6>
                    <p class="card-text">
                        Inventorié(e) par {{ site?.properties.obs_txt }}
                    </p>

                    <p *ngIf="site?.properties.visits.length > 0; else noVisit" class="card-text">
                        <small class="text-muted">
                            <span *ngIf="site?.properties.visits.length === 1">
                                Visite du
                                {{
                                site?.properties.visits[0].date
                                | date: 'longDate'
                                }}
                            </span>
                            <span *ngIf="site?.properties.visits.length > 1">
                                {{ site?.properties.visits.length }} visites
                            </span>
                        </small>
                    </p>
                    <ng-template #noVisit>
                        <p class="card-text">
                            <small class="text-danger">Aucune visite enregistrée :(</small>
                        </p>
                    </ng-template>
                    <a href="#" (click)="$event.preventDefault(); addSiteVisit()" class="btn btn-primary">Ajouter un
                        rapport de visite</a>
                </div>
                <div *ngSwitchDefault>
                    <h5 class="card-title">Observation #{{ obs_id }}</h5>
                    <h6 class="card-subtitle mb-2 text-muted">
                        Ajoutée le
                        {{
                        obs?.properties.timestamp_create.substring(0, 10)
                        | date: 'longDate'
                        }}
                    </h6>
                    <p class="card-text">par {{ obs?.properties.obs_txt }}</p>
                </div>
            </ng-container>
        </div>

        <div class="col-md-8 pr-0">
            <div id="map" class="col-lg-12 species-site-map"></div>
        </div>
    </div>
    <div *ngIf="photos">
        <div *ngIf="photos.length > 0" class="row">
            <h2 class="mt-4 mb-4">Photos</h2>
        </div>
        <div class="row">
            <div *ngFor="let photo of photos" class="col-md-4 cursor-pointer" (click)="showPhoto(photo)">
                <div class="card mb-4 box-shadow">
                    <img class="card-img-top"
                        data-src="holder.js/100px225?theme=thumb&amp;bg=55595c&amp;fg=eceeef&amp;text=Thumbnail"
                        alt="Thumbnail [100%x225]" src="{{ photo.url }}" data-holder-rendered="true" />
                    <div class="card-body">
                        <p class="card-text">
                            {{ photo.date | date: 'longDate' }}
                        </p>
                        <p class="card-text">
                            <small class="text-muted">{{ photo.author }}</small>
                        </p>
                    </div>
                </div>
            </div>
        </div>
        <div *ngIf="module === 'sites'">
            <div *ngIf="attributes.length > 0" class="row">
                <h2 class="my-4">Description</h2>
            </div>
            <!-- {{ attributes|json }} -->
            <!-- <span *ngIf="site">{{ site.properties.visits|json }}</span> -->
            <div *ngFor="let a of attributes" class="row bg-light my-3">
                <h5>
                    <i class="fa fa-calendar"></i>
                    {{ a.date | date: 'longDate' }} par {{ a.author }}
                    <i class="fa fa-edit text-primary" ngbTooltip="Editer" (click)="editSiteVisit(a);"
                        *ngIf="a.author === username"></i>
                    &nbsp;
                    <!-- {{ a|json }} deleteSiteVisit(a.id)-->
                    <i class="fa fa-trash text-danger" ngbTooltip="Supprimer" (click)="openDelVisitModal(a.id)"
                        *ngIf="a.author === username"></i>
                </h5>
                <table class="table table-striped table-sm table-hover">
                    <tbody>
                        <ng-container *ngIf="a.data; else noData">
                            <tr *ngFor="let d of a.data" class="d-flex">
                                <td class="col-4">{{ d.name }}</td>
                                <td class="col-8">{{ d.value }}</td>
                            </tr>
                        </ng-container>
                        <ng-template #noData>
                            <tr class="d-flex">
                                <td class="col-8">Aucune donnée</td>
                            </tr>
                        </ng-template>
                    </tbody>
                </table>
            </div>
        </div>

        <div *ngIf="module === 'observations'">
            <div *ngIf="attributes.length > 0" class="row">
                <h2 class="mt-4 mb-4">Description</h2>
            </div>
            <div class="row bg-light">
                <table class="table table-striped">
                    <tbody>
                        <tr *ngFor="let d of attributes" class="d-flex">
                            <td class="col-4">{{ d.name }}</td>
                            <td class="col-8">{{ d.value }}</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>

        <div *ngIf="module === 'areas' && area?.properties.species_sites && area.properties.species_sites.count > 0">
            <div class="row">
                <h2 class="mt-4 mb-4">Individus</h2>
            </div>
            <div class="row bg-light">
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th scope="col">Nom</th>
                            <th scope="col">Espèce</th>
                            <th scope="col">Dernière obs</th>
                            <th scope="col"></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr *ngFor="let species_site of area.properties.species_sites.features">
                            <td>{{ species_site.properties.name }}</td>
                            <td>
                                {{
                                species_site.properties.species ?
                                species_site.properties.species.nom_vern :
                                ''
                                }}
                            </td>
                            <td>
                                {{
                                species_site.properties.last_observation?.stages_step ?
                                species_site.properties.last_observation.stages_step.name :
                                ''
                                }}
                            </td>
                            <td>
                                <a [routerLink]="[
                                '/programs',
                                area.properties.id_program,
                                'species_sites',
                                species_site.properties.id_species_site
                            ]">
                                    <i class="fa fa-chevron-right mx-3 my-1"></i>
                                </a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <div
            *ngIf="module === 'species_sites' && speciesSite?.properties.observations && speciesSite.properties.observations.count > 0">
            <div class="row">
                <h2 class="mt-4 mb-4">Observations</h2>
            </div>
            <div class="row bg-light">
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th scope="col">Date obs</th>
                            <th scope="col">Dernier stade</th>
                            <th scope="col">Dernière étape</th>
                            <th scope="col"></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr *ngFor="let observation of speciesSite.properties.observations.features">
                            <td>{{ observation.properties.date }}</td>
                            <td>
                                {{
                                observation.properties.stages_step?.species_stage ?
                                observation.properties.stages_step.species_stage.name :
                                ''
                                }}
                            </td>
                            <td>
                                {{ observation.properties.stages_step ? observation.properties.stages_step.name : '' }}
                            </td>
                            <td>
                                <a [routerLink]="[
                                '/programs',
                                speciesSite.properties.area.id_program,
                                'areas-observations',
                                observation.properties.id_species_site_observation
                            ]">
                                    <i class="fa fa-chevron-right mx-3 my-1"></i>
                                </a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="photoModal" tabindex="-1" role="dialog">
    <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">
                    {{ clickedPhoto?.date | date: 'longDate' }}
                </h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <img src="{{ clickedPhoto?.url }}" style="width: 100%" />
                <p class="card-text">
                    <small class="text-muted">{{ clickedPhoto?.author }}</small>
                </p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                    Close
                </button>
            </div>
        </div>
    </div>
</div>

<ng-template #visitDeleteModal let-modal>
    <div class="modal-delete-header">
        <h5 class="modal-delete-title"><i class="fa fa-trash"></i></h5>
    </div>
    <div class="modal-delete-body">
        Êtes-vous sûr de vouloir supprimer cette visite et toutes les informations
        qui y sont rattachées ?
        <br />
        La suppression sera définitive
    </div>
    <div class="modal-delete-footer">
        <button type="button" class="cancel-btn" style="margin-right: 15px" (click)="visitDeleteModalClose()">
            ANNULER
        </button>
        <button type="button" class="green-btn" (click)="deleteSiteVisit(idVisitToDelete); visitDeleteModalClose();">
            OUI
        </button>
    </div>
</ng-template>
